Welcome to mirror list, hosted at ThFree Co, Russian Federation.

git.kernel.org/pub/scm/git/git.git - Unnamed repository; edit this file 'description' to name the repository.
summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJeff King <peff@peff.net>2015-10-27 00:39:39 +0300
committerJunio C Hamano <gitster@pobox.com>2015-10-27 00:49:31 +0300
commit72fac66bca302dbecbe42dfa0ddc7e42db2fe567 (patch)
tree97e26848665103abaa696be186d549e747e7a8ea /git-merge-one-file.sh
parentf78d1fe208d3db36afecbd8b8a84d6c35391bd0b (diff)
merge: detect delete/modechange conflict
If one side deletes a file and the other changes its content, we notice and report a conflict. However, if instead of changing the content, we change only the mode, the merge does not notice (and the mode change is silently dropped). The trivial index merge notices the problem and correctly leaves the conflict in the index, but both merge-recursive and merge-one-file will silently resolve this in favor of the deletion. In many cases that is a sane resolution, but we should be punting to the user whenever there is any question. So let's detect and treat this as a conflict (in both strategies). Signed-off-by: Jeff King <peff@peff.net> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'git-merge-one-file.sh')
-rwxr-xr-xgit-merge-one-file.sh8
1 files changed, 8 insertions, 0 deletions
diff --git a/git-merge-one-file.sh b/git-merge-one-file.sh
index 07dfeb8df4..cdc02af517 100755
--- a/git-merge-one-file.sh
+++ b/git-merge-one-file.sh
@@ -38,6 +38,14 @@ case "${1:-.}${2:-.}${3:-.}" in
# Deleted in both or deleted in one and unchanged in the other
#
"$1.." | "$1.$1" | "$1$1.")
+ if { test -z "$6" && test "$5" != "$7"; } ||
+ { test -z "$7" && test "$5" != "$6"; }
+ then
+ echo "ERROR: File $4 deleted on one branch but had its" >&2
+ echo "ERROR: permissions changed on the other." >&2
+ exit 1
+ fi
+
if test -n "$2"
then
echo "Removing $4"